﻿<template>
    <section class="show-movie">
        <div class="movie-info">
            <h1>{{ t('pages.showMovie.title') }}</h1>
            <h2>{{ props.movie.title }}</h2>
            <hr />

            <p v-if="props.genre" class="movie-genre"><span>Genre : </span>{{ props.genre }}</p>

            <p v-if="props.movie.rating" class="movie-ratings"><span>{{ t('pages.showMovie.rating') }} : </span>{{ props.movie.rating }} / 10</p>
            <p v-if="props.movie.imdbRating" class="movie-ratings"><span>{{ t('pages.showMovie.rating') }} : </span>{{ props.movie.imdbRating }} / 10</p>

            <p v-if="props.movie.year" class="movie-date">
                <span>{{ t('pages.showMovie.releaseDate') }} : </span>{{ props.movie.year }}
            </p>

            <p v-if="props.movie.timeline" class="movie-timeline"><span>{{ t('pages.showMovie.duration') }} : </span>{{ props.movie.timeline }}</p>
        </div>

        <img v-if="props.movie.image" :src="props.movie.image" :alt="'Affiche du film ' + props.movie.title" />
        <img v-if="props.movie.posterImage" :src="props.movie.posterImage" :alt="'Affiche du film ' + props.movie.title" />
    </section>

    <div class="movie-links">
        <p v-if="memberStore.member.email">
            {{ t('pages.showMovie.goToMyMoviesPart1') }}
            <RouterLink :to="t('routes.home.myMovies.fullPath')">{{ t('pages.showMovie.goToMyMoviesLink') }}</RouterLink>
            {{ t('pages.showMovie.goToMyMoviesPart2') }}
        </p>
        <p v-else>{{ t('pages.showMovie.createAccountPart1') }} <RouterLink :to="t('routes.members.add.fullPath')">{{ t('pages.showMovie.createAccountLink') }}</RouterLink> {{ t('pages.showMovie.createAccountPart2') }}</p>
    </div>
</template>

<script lang="ts" setup>
    import { Movie } from "../../types";
    import { useI18n } from "vue3-i18n";
    import { ICreateMovieRequest } from "@/types/requests/createMovieRequest";
    import { useMovieService } from "@/inversify.config";
    import { useMemberStore } from "@/stores/memberStore";
    import { IAddMemberLinkRequest } from "../../types/requests/addMemberLinkRequest";
    import { notifyError, notifySuccess } from "@/notify";

    const memberStore = useMemberStore()

    const { t } = useI18n();
    const movieService = useMovieService();

    // eslint-disable-next-line no-undef
    const props = defineProps<{
        movie: Movie,
        genre?: string
    }>();

    if (memberStore.member.email) {
        let movieDb = await movieService.getMovieByTitle(props.movie.title);
        
        if (!movieDb) {
            let movieReq: ICreateMovieRequest = {
                title: props.movie.title,
                year: props.movie.year,
                timeline: props.movie.timeline,
                rating: props.movie.rating ? props.movie.rating : props.movie.imdbRating,
                image: props.movie.image ? props.movie.image : props.movie.posterImage,
                memberId: memberStore.member.id
            }

            await addMovie(movieReq);
            movieDb = await movieService.getMovieByTitle(props.movie.title);
        }

        if (movieDb && movieDb.id)
            await addMemberLink(movieDb.id)
    }

    async function addMovie(request: ICreateMovieRequest) {
        let succeededOrNotResponse = await movieService.createMovie(request);

        if (!succeededOrNotResponse || !succeededOrNotResponse.succeeded) {
            notifyError(t('validation.movie.add.errorOccured'));
        }
    }
    
    async function addMemberLink(movieId: string) {
        let addMemberLinkReq: IAddMemberLinkRequest = {
            movieId: movieId,
            memberId: memberStore.member.id
        };

        const succeededOrNotResponse = await movieService.addMemberLink(addMemberLinkReq);

        if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
            notifySuccess(t('validation.movie.addMemberLink.success'))
        } else {
            notifyError(t('validation.movie.addMemberLink.errorOccured'))
        }
    }
</script>

<style>
    .btn {
        margin-top: 20px;
    }
</style>